csp-最大的矩形

【CCF】201312-3 最大矩形 试题名称: 最大的矩形 时间限制: 1.0s 内存限制: 256.0MB 问题描述   在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。      请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最 阅读详情

csp-最大的矩形

#include<bits/stdc++.h>
using namespace std;

const int N = 1010;
int h[N];
int f[N][N];

int main()
{
    int n;
    cin >> n;

    for(int i=1;i<=n;i++)
        cin >> h[i];

    for(int i=1;i<=n;i++)
        f[i][i]=h[i];

    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            f[i][j]=min(f[i][j-1],h[j]);
        }
    }

    int res=0,maxn=0;
    //从第i个矩形开始到第j个矩形
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            int t=f[i][j]*(j-i+1);
            if(t>maxn)
                maxn=t;
        }
    }
    cout << maxn << endl;

    return 0;
}

CSP - 201312-3 - 最大的矩形 (C++) 题目 试题编号: 201312-3 试题名称: 最大的矩形 时间限制: 1.0s 内存限制: 256.0MB 问题描述: 问题描述   在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。      请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行... 阅读详情

相关推荐

CSP认证-201312-3-最大的矩形

问题链接 CCF201312-3。 问题描述: 求最大矩形面积 问题分析: 最大矩形的高度一定为某一个矩形的高度,所以从第一个矩形开始遍历,以矩形高度为基准向两边判断,若高度大于基准矩形,则进行延伸,否则停止,当两侧都停止判定时所得出的面积即为当前基准矩形高度下所能得到的最大面积 程序说明: 1.输入ISBN字符串 2.求和并取模 3.将正确的识别码存储在字符c内 4.判断ISBN最后一位是否与c相同 提交后得100分的C++程序如下: #include <iostream> #include.

fabien00的博客 332

ccf csp 认证-最大的矩形

一、题目描述:  在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。   请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最大矩形如下图所示的阴影部分,面积是10。 输入格式   第一行包含一个整数n,即矩形的数量(1...

sunandstarws的博客 1301

LPDDR5X内存技术解析:性能提升与优化策略

内存技术在现代计算系统中扮演着核心角色,其性能直接影响整体系统效率。LPDDR5X作为JEDEC最新标准,通过提升数据传输率至8533Mbps、优化能效比15%以上,并扩展突发长度至32字节,显著提升了移动设备的处理能力。这些改进特别适用于5G通信、AI加速(如昇腾芯片)及8K视频处理等高带宽需求场景。技术原理上,LPDDR5X引入了动态电压频率调整(DVFS)和可编程突发长度等创新机制,有效降低了实际应用中的延迟。在工程实践中,合理的PCB布局和信号完整性验证是确保高速稳定运行的关键。随着AI和8K应用的

weixin_29190169的博客 396

最大的矩形--CCF模拟

问题描述 在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。 请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最大矩形如下图所示的阴影部分,面积是10。 输入格式 第一行包含一个整数n,即矩形的...

weixin_30355437的博客 343

【Python爬虫】爬取企业专利信息

本来是个美好的周末的,但是周五晚上领导给了一个公司名称的Excel,让把这些公司的专利信息爬取下来。本文记录了爬取企业专利信息的心酸过程。码字不易,喜欢请点赞!!! 一、找寻目标网页 在接到这个任务之后,我的内心是拒绝的。但是又不能不干。因此首先我需要先找到有公司专利信息的地方。在一番查找和问了问朋友之后,我知道中国专利网、国家知识产权网、Incopat、天眼查、企查查这些网站上面都有企业的专利...

Asher117的博客 2万+

树莓派4B之OpenCV人脸识别实战:从Haar Cascade到实时检测(保姆级教程)

本教程详细介绍了如何在树莓派4B上部署OpenCV,并利用Haar Cascade算法实现实时人脸识别。内容涵盖从系统环境搭建、算法原理解析到代码逐行讲解与实战调优,为嵌入式AI和计算机视觉初学者提供了一份完整的保姆级实践指南。

p8q9r0的博客 402

CSP认证刷题笔记(3)最大矩形(13年CSP认证第三题)

本文简单介绍了CSP认证中,最大矩形问题的求解思路和代码

hanmo22357的博客 544

海外支付实战:虚拟信用卡订阅ChatGPT Plus等服务的完整指南

在跨境数字服务消费中,支付环节常因地区限制、银行风控等因素受阻。其核心原理在于国际信用卡交易需通过发卡行风控系统,而国内银行对高频、小额或商户名非常规的境外线上交易敏感,导致成功率不稳定。为解决这一痛点,虚拟信用卡技术应运而生,它通过服务商生成关联预充值账户的虚拟卡号,提供地域灵活性与资金可控性,显著提升了支付通过率。这项技术的价值在于以较低学习成本,为个人用户打通了访问ChatGPT Plus、Midjourney、Claude Pro等前沿AI服务的支付通道。其典型应用场景包括订阅各类海外SaaS、内容

weixin_42531579的博客 1017

CCF CSP 编程题目和解答-----试题名称: 最大的矩形 -------201312-3

问题描述  试题编号: 201312-3  试题名称: 最大的矩形  时间限制: 1.0s  内存限制: 256.0MB  问题描述:  问题描述     在横轴上放了 n 个相邻的矩形,每个矩形的宽度是 1,而第 i(1 ≤ i ≤ n)个矩形的高度是 hi。这 n 个矩形构成了一个直方图。例 如,下图中六个矩形的高度就分别是 3, 1, 6, 5, 2, 3。       

木子的博客 1152

20 CVPR Learning 3D Semantic Scene Graphs From 3D Indoor Reconstructions 学习笔记

3RScan是大规模真实世界的室内场景,特点是对478个自然改变的室内环境在不同的时间帧进行了1482 RGB-D scans,每一个scene都包括了一些位置被改变的物体。它和ScanNet数据集的区别主要在于ScanNet中的每一个采样环境都不相同,但是3RScan中存在采样环境相同但物体的位置不同的场景。Scene Graph Annotations 则是在3RScan的基础上给物体加入了场景图需要的关系、物体特征和类别标注,同时对3RScan进行了扩展,以此形成了场景图数据。

weixin_43508459的博客 1834

SAP S4 MM模块自动记账全流程解析:从评估范围到科目分组的实战配置

本文深入解析SAP S4 MM模块自动记账的全流程,从核心概念评估范围与评估控制入手,详细阐述了评估类、科目分组等关键配置的逻辑关系。通过实战配置步骤,指导如何建立从物料移动(如收货、发料)到自动生成准确财务凭证的完整体系,确保库存价值与总账实时同步,为企业构建可靠的财务业务一体化基石。

weixin_29313547的博客 421

csp 最大的矩形(含解析)

思路 首先找到数组中的最大值和最小值,从最小值到最大值循环。 如果数组中的值大于当前值,那么就把标志数组对应位置置为1,最后计算标志数组中连续的1的对应面积。 如下图,如果当前值为2,然后数组中第0位大于当前值,flag[0]置1;同理flag的2、3、4、5位都为1,计算出面积选出最大值。 当前值为3的情况:   C++代码实现 #include <bits/stdc++.h> using namespace std; int main(int argc, char**

weixin_44915226的博客 554

Vue3 - 解决报错 Uncaught (in promise) DOMException: Failed to execute ‘insertBefore‘ on ‘Node‘: The node

vue3,报错,vue3报错,Uncaught(inpromise)DOMException:Failedtoexecute'insertBefore'on'Node':Thenodebeforewhichthenewnodeistobeinsertedisnotachildofthisnode,如何解决这个错误,动态渲染,v-if,v-show,insertBefore,详细解决方法,vue3未能在“Node”上执行“insertBefore”:要插入

🏆 前端领域优质创作者 1万+

CCF-最大的矩形-201312-3

试题编号: 201312-3 试题名称: 最大的矩形 时间限制: 1.0s 内存限制: 256.0MB 问题描述: 问题描述   在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。 请找出能放在给定直方图里面积最大的矩形,它的边要与坐

TWgFWHuD的博客 822

qq邮箱发错误:The “From“ header is missing or invalid. Please follow RFC5322, RFC2047, RFC822 standard pro

如果还报错 (550, b’The mail may contain inappropriate words or content.'),可能是你message[‘From’]中的< senderxxx@qq.com >发送邮箱填错了,必须要和self.sender = ’ senderxxx@qq.com '一样。可能是之前qq邮箱发送协议存在漏洞,可隐藏发送者邮箱。现在换了新协议,导致与原来协议规则、编码出现了一些问题。"python自动发送""python自动发送"

云霄IT的博客 3670

数学建模模型总结

这是本人在两年内准备参加数学建模竞赛搜集到的模型资料,已经经过了本人的筛选和整理,希望能够对准备参加数学建模竞赛的学弟学妹们提供一些帮助!

CSP最大的矩形

试题编号: 3 试题名称: 最大的矩形 时间限制: 1.0s 内存限制: 256.0MB 问题描述: 问题描述 在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。 请找出能放在给定直方图里面积

喜爱兰兰 844

温度PID控制PLC程序

温度PID稳定控制程序,适用于欧姆龙PLC,对其他PLC也具有很大参考价值

csp201312-3最大的矩形

好喜欢早年csp的出题风格QAQ,直接二重循环暴力模拟,dp[i]记录以i为左端点起始的最大矩形面积,tmp记录连续矩形的最小高度(由最低高度决定整体矩形的高度),最后进行遍历得出答案。

m0_64652057的博客 569

蓝牙模块HM-10手册

蓝牙模块HM-10手册,该手册对蓝牙模块HM-10进行了详细的介绍和使用方法以及一些AT指令。

VB摄像头监控

该VB模块可对摄像头捕获的画面进行录像等,可在创建的窗口进行控制

【CCF-CSP】201312-3 最大的矩形(单调栈)

【CCF-CSP】201312-3 最大的矩形 题目 给 n 个数,代表 n 个矩形的高度,将 n 个矩形平放,求能剪出的最大矩形的面积。 n < 1e3。 分析 这题跟 POJ-2559 一样,不过数据很水,暴力也行。 用单调栈可以达到 O(n) 的做法。对于每个数,找到向左向右第一个比当前数小的数的位置,就可以确定包含当前数的矩形的最大宽度,而高度即是当前数的值。 #include &...

Stormjing的博客 616

CSP 201312-3 最大的矩形

问题描述 在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。 请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最大矩形如下图所示的阴影部分,面积是10。    输入格式 第一行包含一个整数n,即矩形的数量(1 ≤ n ≤ 1000)。 第二行包含n 个整数h1, h2, … , hn,相邻的数之间由空格分隔。(1 ≤ hi ≤ 10

qq_45598111的博客 130

CCF CSP 201312-3 最大的矩形 (Python)

问题描述   在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。   请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最大矩形如下图所示的阴影部分,面积是10。 输入格式   第一行包含一个整数n,即矩形的数量(1 ≤ n ≤ 1000)。   第二行包含...

q415827717的博客 210

CSP201312-3:最大的矩形

引言:CSP(http://www.cspro.org/lead/application/ccf/login.jsp)是由中国计算机学会(CCF)发起的"计算机职业资格认证"考试,针对计算机软件开发、软件测试、信息管理等领域的专业人士进行能力认证。认证对象是从事或将要从事IT领域专业技术与技术管理人员,以及高校招考研究生的复试对象。 问题描述   在横轴上放了n个相邻的...

weixin_30460489的博客 95

【CSP试题回顾】201312-3-最大的矩形

CSP-201312-3-最大的矩形。

fzy2003的博客 501

最大的矩形-csp

试题编号: 201312-3 试题名称: 最大的矩形 时间限制: 1.0s 内存限制: 256.0MB 问题描述: 问题描述   在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。 请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出...

qq_41056867的博客 363

CSP 直方图中的最大矩形

题目如下: 问题描述 在横轴上放了n个相邻的矩形,每个矩形的宽度是1,而第i(1 ≤ i ≤ n)个矩形的高度是hi。这n个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是3, 1, 6, 5, 2, 3。 请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最大矩形如下图所示的阴影部分,面积是10。 输入格式 第一行包含一个整数n,即矩形的数量

高筑墙,广积粮,缓称王 1062

13年12月CCF-CSP认证第1题 --《最大的矩形》

在横轴上放了 nn 个相邻的矩形,每个矩形的宽度是 1,而第 i(1≤i≤n)个矩形的高度是 hi。这 n 个矩形构成了一个直方图。例如,下图中六个矩形的高度就分别是 3,1,6,5,2,3。请找出能放在给定直方图里面积最大的矩形,它的边要与坐标轴平行。对于上面给出的例子,最大矩形如下图所示的阴影部分,面积是10。

King_lxh的博客 254

ccf csp 201312-3最大的矩形(python)

历年题解 CCF CSP历年题解(python) 样例输入: 6 3 1 6 5 2 3 题目链接:201312-3最大的矩形 问题分析: 从左到右遍历每个直方图,以该直方图为高,分别向左右找高度大于等于该直方图高的直方图,位置分别记录为l,r(l为负数,r为整数) 例如遍历到第四个直方图索引为3、高为5,向左6>5再1<5停止,记录l=-1即相对于原直方图左移一位,同理得r为0,即该次遍历以(索引3,高度5)得最大面积为10=(r-l+1)*5 满分例程: n=int(input()) s=

weixin_44690402的博客 537
上一篇: csp-回收站选址
下一篇: csp-游戏
评论
成就一亿技术人!
拼手气红包6.0元
还能输入1000个字符
 
 条评论被折叠 查看
添加红包

请填写红包祝福语或标题

个

红包个数最小为10个

元

红包金额最低5元

当前余额3.43元 前往充值 >
需支付:10.00元
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

谁会没有丶遗憾呢

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付元
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值